// Learn TypeScript:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';

    pref: cc.Prefab = null;
    nod: cc.Node = null;
    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    start () {
        this.click();
    }

    click(){
        cc.loader.loadRes("animNode", cc.Prefab, (err,res)=>{
            this.pref = res;
            this.nod = cc.instantiate(res);
            this.node.addChild(this.nod);

            setTimeout(()=>{
                this.del();
            }, 100)
        });
    }

    del(){
        this.nod.destroy();
        setTimeout(()=>{
            var ret = cc.loader.getDependsRecursively(this.pref);
            cc.loader.release(ret);
            // jsb.garbageCollect();

            setTimeout(()=>{
                this.click();
            }, 100)            
        }, 1000);   
    }

    // update (dt) {}
}
